'WZMACNIACZ POMIAROWY
'BASCOM-AVR ver1.11.7.4
'ustawienia
'generator zewntrzny 11.0592Mhz
'1111:CKSEL=111X External Crystal/Resonator High Frequency
$regfile = "AT26DEF.DAT"
$crystal = 11059200

Config Lcdpin = Pin , Db4 = Porta.4 , Db5 = Porta.5 , Db6 = Porta.6 , Db7 = Porta.7 , E = Porta.3 , Rs = Porta.2
Config Lcd = 16 * 1a

'______________________________
'ustawienia konfiguracyjne zamiast CONFIG ADC

Admux = &B00001011
'ADC0+, ADC1-. AVCC, bity dosunite do prawej strony
Adcsr.adps0 = 1                                             ' BitO prescaler
Adcsr.adps1 = 1                                             ' Bit1 prescaler
Adcsr.adps2 = 1                                             ' Bit2 prescaler
'prescaler 128

'Adcsr.adie = 1                                              'Bit3 Aktywuj przerwanie ADC (Interupt I-Bit in SREG muss gesetzt sein)
'Adcsr.adif Bit4 Flaga przerwania
Adcsr.adfr = 0                                              'Bit5 Wyczony Auto Trigger (tryb Single)
Adcsr.aden = 1                                              'Bit7 wcz ADC
Adcsr.adsc = 1                                              'Bit6 Start Conversion (Single o. Free )
'______________________________
Config Pinb.1 = Input
Config Pinb.2 = Input
Config Pinb.3 = Input
Config Pinb.6 = Input

Portb.1 = 1
Portb.2 = 1
Portb.3 = 1
Portb.6 = 1

'zwory
Kom1 Alias Pinb.1                                           'przecinek
Kom2 Alias Pinb.2                                           'przecinek
Bob Alias Pinb.3                                            'warto napicia /warto ADC
Nlc Alias Pinb.6                                            'czy wczy LCD

Dim Lowbyte As Byte                                         'modszy bajt ADC
Dim Highbyte As Byte                                        'starszy bajt ADC

Dim Wx As Word                                              'sowo z ADC hi + lo
Dim Lx As Long
Dim Ly As Long

Dim Modex As Word
Dim Sign As Byte                                            'Miejsce Przecinka

Declare Sub Selmodex()                                      'ustala miejsce przecinka
'______________________________
Sign = 0

If Kom1 = 0 Then
Sign.0 = 0
Else
Sign.0 = 1
End If

If Kom2 = 0 Then
Sign.1 = 0
Else
Sign.1 = 1
End If
'______________________________

If Nlc = 0 Then
Cursor Off
Cls
Lcd "NOWY ELEKTRONIK"
Wait 1
Cls
Lcd "INSOLATION AMP."
Wait 1
Cls
End If
'###############################
Do
'______________________________
Adcsr.adsc = 1                                              ' Bit6 Start Conversion (Singel o. Free )
Do
Loop Until Adcsr.adif = 1                                   ' Warten auf conversation
Adcsr.adif = 0                                              'Reset flag
Adcsr.adsc = 0                                              'Bit6 Start Conversion (Singel o. Free )
Lowbyte = Adcl                                              'Lowbyte Register
Highbyte = Adch                                             'High Byte Register
'______________________________
Wx = Highbyte * 256
Wx = Wx + Lowbyte
'______________________________
If Nlc = 0 Then
Locate 1 , 1
If Bob = 0 Then
Lcd Wx ; ""
Else
Call Selmodex()
Ly = Lx / Modex
Lcd Ly ; ".";
Ly = Lx Mod Modex
Lcd Ly ; ""
End If
Waitms 255
End If
'______________________________
Open "COMB.0:9600,8,N,1"for Output As #1
If Bob = 0 Then
Print #1 , "S";
Printbin #1 , Highbyte;
Printbin #1 , Lowbyte;
Else
Call Selmodex()
Ly = Lx / Modex
Print #1 , Ly ; ".";
Ly = Lx Mod Modex
Print #1 , Ly
End If
Close #1
'____________________________
Loop
'###############################
Sub Selmodex()
Lx = Wx * 4883
Lx = Lx / 2000
Select Case Sign
Case 0 : Modex = 10000
Case 1 : Modex = 1000
Case 2 : Modex = 100
Case 3 : Modex = 10
End Select
End Sub
'###############################